// swift-tools-version:5.5
// The swift-tools-version declares the minimum version of Swift required to build this package.

import PackageDescription

let package = Package(
    name: "aoc2021",
    platforms: [.macOS(.v12)],
    products: [
            .library(
                name: "Runner",
                targets: ["Runner"]),
            .executable(name: "01", targets: ["01"]),
            .executable(name: "02", targets: ["02"]),
            .executable(name: "03", targets: ["03"]),
            .executable(name: "04", targets: ["04"]),
            .executable(name: "05", targets: ["05"]),
            .executable(name: "06", targets: ["06"]),
            .executable(name: "07", targets: ["07"])
        ],
    dependencies: [
        // Dependencies declare other packages that this package depends on.
        // .package(url: /* package url */, from: "1.0.0"),
        /*.package(
              url: "https://github.com/apple/swift-collections.git",
              .upToNextMajor(from: "1.0.0")
        )*/
    ],
    targets: [
        // Targets are the basic building blocks of a package. A target can define a module or a test suite.
        // Targets can depend on other targets in this package, and on products in packages this package depends on.
        .target(
            name: "Runner",
            path: "Sources/Runner",
            resources: [.process("Resources")]
        ),
        .executableTarget(
            name: "01",
            dependencies: [.targetItem(name: "Runner", condition: nil)]
        ),
        .executableTarget(
            name: "02",
            dependencies: [.targetItem(name: "Runner", condition: nil)]
        ),
        .executableTarget(
            name: "03",
            dependencies: [.targetItem(name: "Runner", condition: nil)]
        ),
        .executableTarget(
            name: "04",
            dependencies: [
                .targetItem(name: "Runner", condition: nil)
            ],
            resources: []
        ),
        .executableTarget(
            name: "05",
            dependencies: [
                //.product(name: "Collections", package: "swift-collections")
                .targetItem(name: "Runner", condition: nil)
            ],
            resources: []
        ),
        .executableTarget(
            name: "06",
            dependencies: [.targetItem(name: "Runner", condition: nil)]
        ),
        .executableTarget(
            name: "07",
            dependencies: [.targetItem(name: "Runner", condition: nil)]
        )
    ]
)
